package r08.r08_13;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class PrimitiveTypeStreams {
    public static void show(String title, IntStream stream) {
        final int SIZE = 10;
        int[] firstElements = stream.limit(SIZE + 1).toArray();
        System.out.print(title + ": [");
        int i;
        for (i = 0; i < SIZE && i < firstElements.length; i++) {
            System.out.print(firstElements[i]);
            if (i < firstElements.length - 1)
                System.out.print(", ");
        }
        if (i < firstElements.length)
            System.out.print("...");
        System.out.println("]");
    }

    public static void main(String[] args) throws IOException {
        IntStream is1 = IntStream.generate(() -> (int) (Math.random() * 100));
        show("is1", is1);
        IntStream is2 = IntStream.range(5, 10);
        show("is2", is2);
        IntStream is3 = IntStream.rangeClosed(5, 10);
        show("is3", is3);

        String contents = Files.readString(Path.of("zemsta.txt"));

        Stream<String> słowa = Stream.of(contents.split("\\PL+"));
        IntStream is4 = słowa.mapToInt(String::length);
        show("is4", is4);
        String zdanie = "\uD835\uDD46 to zbiór oktonionów.";
        System.out.println(zdanie);
        IntStream kody = zdanie.codePoints();
        System.out.println(kody.mapToObj(c -> "%X ".formatted(c)).collect(
                Collectors.joining()));

        Stream<Integer> liczby = IntStream.range(0, 100).boxed();
        IntStream is5 = liczby.mapToInt(Integer::intValue);
        show("is5", is5);
    }
}
