package r12.r12_05;

import java.time.*;

public class ZonedTimes {
    public static void main(String[] args) {
        ZonedDateTime startApollo11 = ZonedDateTime.of(1969, 7, 16, 9, 32, 0, 0, 
            ZoneId.of("America/New_York"));
        // 1969-07-16T09:32-04:00[America/New_York]
        System.out.println("startApollo11: " + startApollo11);

        Instant instant = startApollo11.toInstant();
        System.out.println("instant: " + instant);

        ZonedDateTime zonedDateTime = instant.atZone(ZoneId.of("UTC"));
        System.out.println("zonedDateTime: " + zonedDateTime);

        ZonedDateTime przeskoczone = ZonedDateTime.of(
            LocalDate.of(2013, 3, 31),
            LocalTime.of(2, 30),
            ZoneId.of("Europe/Berlin"));
        // Tworzy 31 marca, 3:30
        System.out.println("przeskoczone: " + przeskoczone);

        ZonedDateTime niejednoznaczne = ZonedDateTime.of(
            LocalDate.of(2013, 10, 27), 
            // Koniec czasu letniego
            LocalTime.of(2, 30),
            ZoneId.of("Europe/Berlin"));
        // 2013-10-27T02:30+02:00[Europe/Berlin]
        ZonedDateTime godzinęPóźniej = niejednoznaczne.plusHours(1);
        // 2013-10-27T02:30+01:00[Europe/Berlin]
        System.out.println("niejednoznaczne: " + niejednoznaczne);
        System.out.println("godzinęPóźniej: " + godzinęPóźniej);

        ZonedDateTime meeting = ZonedDateTime.of(
            LocalDate.of(2013, 10, 31),
            LocalTime.of(14, 30),
            ZoneId.of("America/Los_Angeles"));
        System.out.println("spotkanie: " + meeting);
        ZonedDateTime nextMeeting = meeting.plus(Duration.ofDays(7));
        // Uwaga! Nie zadziała przy sezonowej zmianie czasu
        System.out.println("kolejneSpotkanie: " + nextMeeting);
        nextMeeting = meeting.plus(Period.ofDays(7)); // OK
        System.out.println("kolejneSpotkanie: " + nextMeeting);
    }
}
